<?php

namespace Lc\CaracoleBundle\Field\Filter;

use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\QueryBuilder;
use EasyCorp\Bundle\EasyAdminBundle\Dto\FieldDto;
use Lc\SovBundle\Field\Filter\AssociationFilter;
use Lc\SovBundle\Field\Filter\FilterTrait;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\FormBuilderInterface;

/**
 * @author La clic ! <contact@laclic.fr>
 */
class ProductCategoriesFilter extends AssociationFilter
{
    public function buildProperty(FormBuilderInterface $builder, FieldDto $fieldDto, $options = array())
    {
        $targetEntity = $options['entity_dto']->getPropertyMetadata($fieldDto->getProperty())->get('targetEntity');

        $builder->add(
            $fieldDto->getProperty(),
            EntityType::class,
            array(
                'class' => $targetEntity,
                'placeholder' => '--',
                'choices' => $fieldDto->getFormTypeOption('choices'),
                'required' => false,
                'attr' => array(
                    'class' => 'select2 input-sm',
                    'form' => 'filters-form',
                ),


            )
        );
    }


    public function applyFilter(QueryBuilder $queryBuilder, string $fieldProperty, $filteredValue = null)
    {
        if ($filteredValue !== null) {
            $queryBuilder->leftJoin('entity.productCategories', 'product_categories');
            $queryBuilder->andWhere(':' . $fieldProperty . ' MEMBER OF entity.' . $fieldProperty . ' OR product_categories.parent = :' . $fieldProperty);
            $queryBuilder->setParameter($fieldProperty, $filteredValue);

        }
    }

}
