<?php

namespace Lc\CaracoleBundle\Repository\Product;

use Lc\CaracoleBundle\Model\Product\ProductCategoryInterface;
use Lc\CaracoleBundle\Repository\SectionStoreTrait;
use Lc\SovBundle\Repository\AbstractStore;
use Lc\SovBundle\Repository\RepositoryQueryInterface;

class ProductCategoryStore extends AbstractStore
{
    use SectionStoreTrait;

    protected ProductCategoryRepositoryQuery $query;

    public function __construct(ProductCategoryRepositoryQuery $query)
    {
        $this->query = $query;
    }

    public function orderByDefault(RepositoryQueryInterface $query): RepositoryQueryInterface
    {
        $query->orderBy('position');
        return $query;
    }

    public function filtersDefault(RepositoryQueryInterface $query): RepositoryQueryInterface
    {
        $query->filterBySection($this->section);
        return $query;
    }

    public function relationsDefault($query): RepositoryQueryInterface
    {
        return $query;
    }

    public function getOneParent(): ?ProductCategoryInterface
    {
        $query = $this->createDefaultQuery();
        $query->filterIsParent();
        return $query->findOne();
    }
}
